/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 21:02:08 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.orkut.model;

/**
 * Model definition for Comment.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Orkut API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Comment extends com.google.api.client.json.GenericJson {

  /**
   * The person who posted the comment.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private OrkutAuthorResource actor;

  /**
   * The content of the comment in text/html
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String content;

  /**
   * The unique ID for the comment.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * Link to the original activity where this comment was posted.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private InReplyTo inReplyTo;

  /**
   * Identifies this resource as a comment. Value: "orkut#comment"
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * List of resources for the comment.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<OrkutLinkResource> links;

  static {
    // hack to force ProGuard to consider OrkutLinkResource used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(OrkutLinkResource.class);
  }

  /**
   * The time the comment was initially published, in RFC 3339 format.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime published;

  /**
   * The person who posted the comment.
   * @return value or {@code null} for none
   */
  public OrkutAuthorResource getActor() {
    return actor;
  }

  /**
   * The person who posted the comment.
   * @param actor actor or {@code null} for none
   */
  public Comment setActor(OrkutAuthorResource actor) {
    this.actor = actor;
    return this;
  }

  /**
   * The content of the comment in text/html
   * @return value or {@code null} for none
   */
  public java.lang.String getContent() {
    return content;
  }

  /**
   * The content of the comment in text/html
   * @param content content or {@code null} for none
   */
  public Comment setContent(java.lang.String content) {
    this.content = content;
    return this;
  }

  /**
   * The unique ID for the comment.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * The unique ID for the comment.
   * @param id id or {@code null} for none
   */
  public Comment setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * Link to the original activity where this comment was posted.
   * @return value or {@code null} for none
   */
  public InReplyTo getInReplyTo() {
    return inReplyTo;
  }

  /**
   * Link to the original activity where this comment was posted.
   * @param inReplyTo inReplyTo or {@code null} for none
   */
  public Comment setInReplyTo(InReplyTo inReplyTo) {
    this.inReplyTo = inReplyTo;
    return this;
  }

  /**
   * Identifies this resource as a comment. Value: "orkut#comment"
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies this resource as a comment. Value: "orkut#comment"
   * @param kind kind or {@code null} for none
   */
  public Comment setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * List of resources for the comment.
   * @return value or {@code null} for none
   */
  public java.util.List<OrkutLinkResource> getLinks() {
    return links;
  }

  /**
   * List of resources for the comment.
   * @param links links or {@code null} for none
   */
  public Comment setLinks(java.util.List<OrkutLinkResource> links) {
    this.links = links;
    return this;
  }

  /**
   * The time the comment was initially published, in RFC 3339 format.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getPublished() {
    return published;
  }

  /**
   * The time the comment was initially published, in RFC 3339 format.
   * @param published published or {@code null} for none
   */
  public Comment setPublished(com.google.api.client.util.DateTime published) {
    this.published = published;
    return this;
  }

  @Override
  public Comment set(String fieldName, Object value) {
    return (Comment) super.set(fieldName, value);
  }

  @Override
  public Comment clone() {
    return (Comment) super.clone();
  }

  /**
   * Link to the original activity where this comment was posted.
   */
  public static final class InReplyTo extends com.google.api.client.json.GenericJson {

    /**
     * Link to the post on activity stream being commented.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String href;

    /**
     * Unique identifier of the post on activity stream being commented.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String ref;

    /**
     * Relationship between the comment and the post on activity stream being commented. Always
     * inReplyTo.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String rel;

    /**
     * Type of the post on activity stream being commented. Always text/html.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String type;

    /**
     * Link to the post on activity stream being commented.
     * @return value or {@code null} for none
     */
    public java.lang.String getHref() {
      return href;
    }

    /**
     * Link to the post on activity stream being commented.
     * @param href href or {@code null} for none
     */
    public InReplyTo setHref(java.lang.String href) {
      this.href = href;
      return this;
    }

    /**
     * Unique identifier of the post on activity stream being commented.
     * @return value or {@code null} for none
     */
    public java.lang.String getRef() {
      return ref;
    }

    /**
     * Unique identifier of the post on activity stream being commented.
     * @param ref ref or {@code null} for none
     */
    public InReplyTo setRef(java.lang.String ref) {
      this.ref = ref;
      return this;
    }

    /**
     * Relationship between the comment and the post on activity stream being commented. Always
     * inReplyTo.
     * @return value or {@code null} for none
     */
    public java.lang.String getRel() {
      return rel;
    }

    /**
     * Relationship between the comment and the post on activity stream being commented. Always
     * inReplyTo.
     * @param rel rel or {@code null} for none
     */
    public InReplyTo setRel(java.lang.String rel) {
      this.rel = rel;
      return this;
    }

    /**
     * Type of the post on activity stream being commented. Always text/html.
     * @return value or {@code null} for none
     */
    public java.lang.String getType() {
      return type;
    }

    /**
     * Type of the post on activity stream being commented. Always text/html.
     * @param type type or {@code null} for none
     */
    public InReplyTo setType(java.lang.String type) {
      this.type = type;
      return this;
    }

    @Override
    public InReplyTo set(String fieldName, Object value) {
      return (InReplyTo) super.set(fieldName, value);
    }

    @Override
    public InReplyTo clone() {
      return (InReplyTo) super.clone();
    }

  }

}
