/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 21:02:08 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.orkut.model;

/**
 * Model definition for OrkutActivityobjectsResource.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Orkut API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class OrkutActivityobjectsResource extends com.google.api.client.json.GenericJson {

  /**
   * The community which is related with this activity, e.g. a joined community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Community community;

  /**
   * The HTML-formatted content, suitable for display. When updating an activity's content, post the
   * changes to this property, using the value of originalContent as a starting point. If the update
   * is successful, the server adds HTML formatting and responds with this formatted content.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String content;

  /**
   * The title of the object.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String displayName;

  /**
   * The ID for the object.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * Links to other resources related to this object.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<OrkutLinkResource> links;

  static {
    // hack to force ProGuard to consider OrkutLinkResource used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(OrkutLinkResource.class);
  }

  /**
   * The object type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String objectType;

  /**
   * The person who is related with this activity, e.g. an Added User.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private OrkutActivitypersonResource person;

  /**
   * The community which is related with this activity, e.g. a joined community.
   * @return value or {@code null} for none
   */
  public Community getCommunity() {
    return community;
  }

  /**
   * The community which is related with this activity, e.g. a joined community.
   * @param community community or {@code null} for none
   */
  public OrkutActivityobjectsResource setCommunity(Community community) {
    this.community = community;
    return this;
  }

  /**
   * The HTML-formatted content, suitable for display. When updating an activity's content, post the
   * changes to this property, using the value of originalContent as a starting point. If the update
   * is successful, the server adds HTML formatting and responds with this formatted content.
   * @return value or {@code null} for none
   */
  public java.lang.String getContent() {
    return content;
  }

  /**
   * The HTML-formatted content, suitable for display. When updating an activity's content, post the
   * changes to this property, using the value of originalContent as a starting point. If the update
   * is successful, the server adds HTML formatting and responds with this formatted content.
   * @param content content or {@code null} for none
   */
  public OrkutActivityobjectsResource setContent(java.lang.String content) {
    this.content = content;
    return this;
  }

  /**
   * The title of the object.
   * @return value or {@code null} for none
   */
  public java.lang.String getDisplayName() {
    return displayName;
  }

  /**
   * The title of the object.
   * @param displayName displayName or {@code null} for none
   */
  public OrkutActivityobjectsResource setDisplayName(java.lang.String displayName) {
    this.displayName = displayName;
    return this;
  }

  /**
   * The ID for the object.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * The ID for the object.
   * @param id id or {@code null} for none
   */
  public OrkutActivityobjectsResource setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * Links to other resources related to this object.
   * @return value or {@code null} for none
   */
  public java.util.List<OrkutLinkResource> getLinks() {
    return links;
  }

  /**
   * Links to other resources related to this object.
   * @param links links or {@code null} for none
   */
  public OrkutActivityobjectsResource setLinks(java.util.List<OrkutLinkResource> links) {
    this.links = links;
    return this;
  }

  /**
   * The object type.
   * @return value or {@code null} for none
   */
  public java.lang.String getObjectType() {
    return objectType;
  }

  /**
   * The object type.
   * @param objectType objectType or {@code null} for none
   */
  public OrkutActivityobjectsResource setObjectType(java.lang.String objectType) {
    this.objectType = objectType;
    return this;
  }

  /**
   * The person who is related with this activity, e.g. an Added User.
   * @return value or {@code null} for none
   */
  public OrkutActivitypersonResource getPerson() {
    return person;
  }

  /**
   * The person who is related with this activity, e.g. an Added User.
   * @param person person or {@code null} for none
   */
  public OrkutActivityobjectsResource setPerson(OrkutActivitypersonResource person) {
    this.person = person;
    return this;
  }

  @Override
  public OrkutActivityobjectsResource set(String fieldName, Object value) {
    return (OrkutActivityobjectsResource) super.set(fieldName, value);
  }

  @Override
  public OrkutActivityobjectsResource clone() {
    return (OrkutActivityobjectsResource) super.clone();
  }

}
