/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-06 at 21:02:08 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.orkut.model;

/**
 * Model definition for OrkutCommunitypolloptionResource.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Orkut API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class OrkutCommunitypolloptionResource extends com.google.api.client.json.GenericJson {

  /**
   * The option description.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String description;

  /**
   * Image data about the poll option. Field is omitted if no image exists.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Image image;

  /**
   * The total number of votes that this option received.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer numberOfVotes;

  /**
   * The poll option ID
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer optionId;

  /**
   * The option description.
   * @return value or {@code null} for none
   */
  public java.lang.String getDescription() {
    return description;
  }

  /**
   * The option description.
   * @param description description or {@code null} for none
   */
  public OrkutCommunitypolloptionResource setDescription(java.lang.String description) {
    this.description = description;
    return this;
  }

  /**
   * Image data about the poll option. Field is omitted if no image exists.
   * @return value or {@code null} for none
   */
  public Image getImage() {
    return image;
  }

  /**
   * Image data about the poll option. Field is omitted if no image exists.
   * @param image image or {@code null} for none
   */
  public OrkutCommunitypolloptionResource setImage(Image image) {
    this.image = image;
    return this;
  }

  /**
   * The total number of votes that this option received.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getNumberOfVotes() {
    return numberOfVotes;
  }

  /**
   * The total number of votes that this option received.
   * @param numberOfVotes numberOfVotes or {@code null} for none
   */
  public OrkutCommunitypolloptionResource setNumberOfVotes(java.lang.Integer numberOfVotes) {
    this.numberOfVotes = numberOfVotes;
    return this;
  }

  /**
   * The poll option ID
   * @return value or {@code null} for none
   */
  public java.lang.Integer getOptionId() {
    return optionId;
  }

  /**
   * The poll option ID
   * @param optionId optionId or {@code null} for none
   */
  public OrkutCommunitypolloptionResource setOptionId(java.lang.Integer optionId) {
    this.optionId = optionId;
    return this;
  }

  @Override
  public OrkutCommunitypolloptionResource set(String fieldName, Object value) {
    return (OrkutCommunitypolloptionResource) super.set(fieldName, value);
  }

  @Override
  public OrkutCommunitypolloptionResource clone() {
    return (OrkutCommunitypolloptionResource) super.clone();
  }

  /**
   * Image data about the poll option. Field is omitted if no image exists.
   */
  public static final class Image extends com.google.api.client.json.GenericJson {

    /**
     * A URL that points to an image of the poll question.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String url;

    /**
     * A URL that points to an image of the poll question.
     * @return value or {@code null} for none
     */
    public java.lang.String getUrl() {
      return url;
    }

    /**
     * A URL that points to an image of the poll question.
     * @param url url or {@code null} for none
     */
    public Image setUrl(java.lang.String url) {
      this.url = url;
      return this;
    }

    @Override
    public Image set(String fieldName, Object value) {
      return (Image) super.set(fieldName, value);
    }

    @Override
    public Image clone() {
      return (Image) super.clone();
    }

  }

}
